org.codehaus.plexus.util.xml.pull

## Class MXSerializer

- java.lang.Object
- - org.codehaus.plexus.util.xml.pull.MXSerializer

All Implemented Interfaces:
  XmlSerializer

    public class MXSerializer
    extends Object
    implements XmlSerializer

Implementation of XmlSerializer interface from XmlPull V1 API. This implementation is optimized for performance and low memory footprint.

Implemented features:

- FEATURE_NAMES_INTERNED - when enabled all returned names (namespaces, prefixes) will be interned and it is required that all names passed as arguments MUST be interned
- FEATURE_SERIALIZER_ATTVALUE_USE_APOSTROPHE

Implemented properties:

- PROPERTY_SERIALIZER_INDENTATION
- PROPERTY_SERIALIZER_LINE_SEPARATOR

### Field Summary

Fields
`protected boolean` `attributeUseApostrophe`
`protected int` `autoDeclaredPrefixes`
`protected char[]` `buf`
`protected int` `depth`
`protected boolean` `doIndent`
`protected String[]` `elName`
`protected String[]` `elNamespace`
`protected int[]` `elNamespaceCount`
`protected String` `FEATURE_NAMES_INTERNED`
`protected String` `FEATURE_SERIALIZER_ATTVALUE_USE_APOSTROPHE`
`protected boolean` `finished`
`protected char[]` `indentationBuf`
`protected int` `indentationJump`
`protected String` `indentationString`
`protected String` `lineSeparator`
`protected String` `location`
`protected int` `maxIndentLevel`
`protected boolean` `namesInterned`
`protected int` `namespaceEnd`
`protected String[]` `namespacePrefix`
`protected String[]` `namespaceUri`
`protected int` `offsetNewLine`
`protected Writer` `out`
`protected boolean` `pastRoot`
`protected static String[]` `precomputedPrefixes`
`protected static String` `PROPERTY_LOCATION`
`protected String` `PROPERTY_SERIALIZER_INDENTATION`
`protected String` `PROPERTY_SERIALIZER_LINE_SEPARATOR`
`protected boolean` `seenBracket`
`protected boolean` `seenBracketBracket`
`protected boolean` `seenTag`
`protected boolean` `setPrefixCalled`
`protected boolean` `startTagIncomplete`
`protected boolean` `writeIndentation`
`protected boolean` `writeLineSepartor`
`protected static String` `XML_URI`
`protected static String` `XMLNS_URI`

### Constructor Summary

Constructors
Constructor and Description
`MXSerializer()`

### Method Summary

Methods
`XmlSerializer` `attribute(String namespace, String name, String value)` Write an attribute.
`void` `cdsect(String text)`
`protected void` `closeStartTag()`
`void` `comment(String text)`
`void` `docdecl(String text)`
`void` `endDocument()` Finish writing.
`XmlSerializer` `endTag(String namespace, String name)` Write end tag.
`protected void` `ensureElementsCapacity()`
`protected void` `ensureNamespacesCapacity()`
`void` `entityRef(String text)`
`void` `flush()` Write all pending output to the stream.
`int` `getDepth()` Returns the current depth of the element.
`boolean` `getFeature(String name)` Return the current value of the feature with given name.
`String` `getName()` Returns the name of the current element as set by startTag().
`String` `getNamespace()` Returns the namespace URI of the current element as set by startTag().
`String` `getPrefix(String namespace, boolean generatePrefix)` Return namespace that corresponds to given prefix If there is no prefix bound to this namespace return null but if generatePrefix is false then return generated prefix.
`Object` `getProperty(String name)` Look up the value of a property.
`Writer` `getWriter()`
`void` `ignorableWhitespace(String text)`
`protected String` `lookupOrDeclarePrefix(String namespace)`
`protected static String` `printable(char ch)`
`protected static String` `printable(String s)` simple utility method -- good for debugging
`void` `processingInstruction(String text)`
`protected void` `rebuildIndentationBuf()` For maximum efficiency when writing indents the required output is pre-computed This is internal function that recomputes buffer after user requested chnages.
`protected void` `reset()`
`void` `setFeature(String name, boolean state)` Set feature identified by name (recommended to be URI for uniqueness).
`void` `setOutput(OutputStream os, String encoding)` Set to use binary output stream with given encoding.
`void` `setOutput(Writer writer)` Set the output to the given writer.
`void` `setPrefix(String prefix, String namespace)` Binds the given prefix to the given namespace.
`void` `setProperty(String name, Object value)` Set the value of a property.
`void` `startDocument(String encoding, Boolean standalone)` Write <?xml declaration with encoding (if encoding not null) and standalone flag (if standalone not null) This method can only be called just after setOutput.
`XmlSerializer` `startTag(String namespace, String name)` Writes a start tag with the given namespace and name.
`XmlSerializer` `text(char[] buf, int start, int len)` Writes text, where special XML chars are escaped automatically
`XmlSerializer` `text(String text)` Writes text, where special XML chars are escaped automatically
`protected void` `writeAttributeValue(String value, Writer out)`
`protected void` `writeElementContent(char[] buf, int off, int len, Writer out)`
`protected void` `writeElementContent(String text, Writer out)`
`protected void` `writeIndent()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### XML_URI

    protected static final String XML_URI

See Also:
  Constant Field Values

#### XMLNS_URI

    protected static final String XMLNS_URI

See Also:
  Constant Field Values

#### FEATURE_SERIALIZER_ATTVALUE_USE_APOSTROPHE

    protected final String FEATURE_SERIALIZER_ATTVALUE_USE_APOSTROPHE

See Also:
  Constant Field Values

#### FEATURE_NAMES_INTERNED

    protected final String FEATURE_NAMES_INTERNED

See Also:
  Constant Field Values

#### PROPERTY_SERIALIZER_INDENTATION

    protected final String PROPERTY_SERIALIZER_INDENTATION

See Also:
  Constant Field Values

#### PROPERTY_SERIALIZER_LINE_SEPARATOR

    protected final String PROPERTY_SERIALIZER_LINE_SEPARATOR

See Also:
  Constant Field Values

#### PROPERTY_LOCATION

    protected static final String PROPERTY_LOCATION

See Also:
  Constant Field Values

#### namesInterned

    protected boolean namesInterned

#### attributeUseApostrophe

    protected boolean attributeUseApostrophe

#### indentationString

    protected String indentationString

#### lineSeparator

    protected String lineSeparator

#### location

    protected String location

#### out

    protected Writer out

#### autoDeclaredPrefixes

    protected int autoDeclaredPrefixes

#### depth

    protected int depth

#### elNamespace

    protected String[] elNamespace

#### elName

    protected String[] elName

#### elNamespaceCount

    protected int[] elNamespaceCount

#### namespaceEnd

    protected int namespaceEnd

#### namespacePrefix

    protected String[] namespacePrefix

#### namespaceUri

    protected String[] namespaceUri

#### finished

    protected boolean finished

#### pastRoot

    protected boolean pastRoot

#### setPrefixCalled

    protected boolean setPrefixCalled

#### startTagIncomplete

    protected boolean startTagIncomplete

#### doIndent

    protected boolean doIndent

#### seenTag

    protected boolean seenTag

#### seenBracket

    protected boolean seenBracket

#### seenBracketBracket

    protected boolean seenBracketBracket

#### buf

    protected char[] buf

#### precomputedPrefixes

    protected static final String[] precomputedPrefixes

#### offsetNewLine

    protected int offsetNewLine

#### indentationJump

    protected int indentationJump

#### indentationBuf

    protected char[] indentationBuf

#### maxIndentLevel

    protected int maxIndentLevel

#### writeLineSepartor

    protected boolean writeLineSepartor

#### writeIndentation

    protected boolean writeIndentation

### Constructor Detail

#### MXSerializer

    public MXSerializer()

### Method Detail

#### reset

    protected void reset()

#### ensureElementsCapacity

    protected void ensureElementsCapacity()

#### ensureNamespacesCapacity

    protected void ensureNamespacesCapacity()

#### setFeature

    public void setFeature(String name,
                  boolean state)
                    throws IllegalArgumentException,
                           IllegalStateException

Description copied from interface: `XmlSerializer`
Set feature identified by name (recommended to be URI for uniqueness). Some well known optional features are defined in http://www.xmlpull.org/v1/doc/features.html. If feature is not recognized or can not be set then IllegalStateException MUST be thrown.

Specified by:
  `setFeature` in interface `XmlSerializer`
Throws:
  `IllegalStateException` - If the feature is not supported or can not be set
  `IllegalArgumentException`

#### getFeature

    public boolean getFeature(String name)
                       throws IllegalArgumentException

Description copied from interface: `XmlSerializer`
Return the current value of the feature with given name.

NOTE: unknown properties are always returned as null

Specified by:
  `getFeature` in interface `XmlSerializer`
Parameters:
  `name` - The name of feature to be retrieved.
Returns:
  The value of named feature.
Throws:
  `IllegalArgumentException` - if feature string is null

#### rebuildIndentationBuf

    protected void rebuildIndentationBuf()

For maximum efficiency when writing indents the required output is pre-computed This is internal function that recomputes buffer after user requested chnages.

#### writeIndent

    protected void writeIndent()
                        throws IOException

Throws:
  `IOException`

#### setProperty

    public void setProperty(String name,
                   Object value)
                     throws IllegalArgumentException,
                            IllegalStateException

Description copied from interface: `XmlSerializer`
Set the value of a property. (the property name is recommended to be URI for uniqueness). Some well known optional properties are defined in http://www.xmlpull.org/v1/doc/properties.html. If property is not recognized or can not be set then IllegalStateException MUST be thrown.

Specified by:
  `setProperty` in interface `XmlSerializer`
Throws:
  `IllegalStateException` - if the property is not supported or can not be set
  `IllegalArgumentException`

#### getProperty

    public Object getProperty(String name)
                       throws IllegalArgumentException

Description copied from interface: `XmlSerializer`
Look up the value of a property. The property name is any fully-qualified URI. I

NOTE: unknown properties are <string>always returned as null

Specified by:
  `getProperty` in interface `XmlSerializer`
Parameters:
  `name` - The name of property to be retrieved.
Returns:
  The value of named property.
Throws:
  `IllegalArgumentException`

#### getWriter

    public Writer getWriter()

#### setOutput

    public void setOutput(Writer writer)

Description copied from interface: `XmlSerializer`
Set the output to the given writer.

WARNING no information about encoding is available!

Specified by:
  `setOutput` in interface `XmlSerializer`

#### setOutput

    public void setOutput(OutputStream os,
                 String encoding)
                   throws IOException

Description copied from interface: `XmlSerializer`
Set to use binary output stream with given encoding.

Specified by:
  `setOutput` in interface `XmlSerializer`
Throws:
  `IOException`

#### startDocument

    public void startDocument(String encoding,
                     Boolean standalone)
                       throws IOException

Description copied from interface: `XmlSerializer`
Write <?xml declaration with encoding (if encoding not null) and standalone flag (if standalone not null) This method can only be called just after setOutput.

Specified by:
  `startDocument` in interface `XmlSerializer`
Throws:
  `IOException`

#### endDocument

    public void endDocument()
                     throws IOException

Description copied from interface: `XmlSerializer`
Finish writing. All unclosed start tags will be closed and output will be flushed. After calling this method no more output can be serialized until next call to setOutput()

Specified by:
  `endDocument` in interface `XmlSerializer`
Throws:
  `IOException`

#### setPrefix

    public void setPrefix(String prefix,
                 String namespace)
                   throws IOException

Description copied from interface: `XmlSerializer`
Binds the given prefix to the given namespace. This call is valid for the next element including child elements. The prefix and namespace MUST be always declared even if prefix is not used in element (startTag() or attribute()) - for XML 1.0 it must result in declaring `xmlns:prefix='namespace'` (or `xmlns:prefix="namespace"` depending what character is used to quote attribute value).

NOTE: this method MUST be called directly before startTag() and if anything but startTag() or setPrefix() is called next there will be exception.

NOTE: prefixes "xml" and "xmlns" are already bound and can not be redefined see: Namespaces in XML Errata.

NOTE: to set default namespace use as prefix empty string.

Specified by:
  `setPrefix` in interface `XmlSerializer`
Parameters:
  `prefix` - must be not null (or IllegalArgumentException is thrown)
  `namespace` - must be not null
Throws:
  `IOException`

#### lookupOrDeclarePrefix

    protected String lookupOrDeclarePrefix(String namespace)

#### getPrefix

    public String getPrefix(String namespace,
                   boolean generatePrefix)

Description copied from interface: `XmlSerializer`
Return namespace that corresponds to given prefix If there is no prefix bound to this namespace return null but if generatePrefix is false then return generated prefix.

NOTE: if the prefix is empty string "" and default namespace is bound to this prefix then empty string ("") is returned.

NOTE: prefixes "xml" and "xmlns" are already bound will have values as defined Namespaces in XML specification

Specified by:
  `getPrefix` in interface `XmlSerializer`

#### getDepth

    public int getDepth()

Description copied from interface: `XmlSerializer`
Returns the current depth of the element. Outside the root element, the depth is 0. The depth is incremented by 1 when startTag() is called. The depth is decremented after the call to endTag() event was observed.

     <!-- outside -->     0
     <root>               1
       sometext                 1
         <foobar>         2
         </foobar>        2
     </root>              1
     <!-- outside -->     0

Specified by:
  `getDepth` in interface `XmlSerializer`

#### getNamespace

    public String getNamespace()

Description copied from interface: `XmlSerializer`
Returns the namespace URI of the current element as set by startTag().

NOTE: that means in particular that:

- if there was startTag("", ...) then getNamespace() returns ""
- if there was startTag(null, ...) then getNamespace() returns null

Specified by:
  `getNamespace` in interface `XmlSerializer`
Returns:
  namespace set by startTag() that is currently in scope

#### getName

    public String getName()

Description copied from interface: `XmlSerializer`
Returns the name of the current element as set by startTag(). It can only be null before first call to startTag() or when last endTag() is called to close first startTag().

Specified by:
  `getName` in interface `XmlSerializer`
Returns:
  namespace set by startTag() that is currently in scope

#### startTag

    public XmlSerializer startTag(String namespace,
                         String name)
                           throws IOException

Description copied from interface: `XmlSerializer`
Writes a start tag with the given namespace and name. If there is no prefix defined for the given namespace, a prefix will be defined automatically. The explicit prefixes for namespaces can be established by calling setPrefix() immediately before this method. If namespace is null no namespace prefix is printed but just name. If namespace is empty string then serializer will make sure that default empty namespace is declared (in XML 1.0 xmlns='') or throw IllegalStateException if default namespace is already bound to non-empty string.

Specified by:
  `startTag` in interface `XmlSerializer`
Throws:
  `IOException`

#### attribute

    public XmlSerializer attribute(String namespace,
                          String name,
                          String value)
                            throws IOException

Description copied from interface: `XmlSerializer`
Write an attribute. Calls to attribute() MUST follow a call to startTag() immediately. If there is no prefix defined for the given namespace, a prefix will be defined automatically. If namespace is null or empty string no namespace prefix is printed but just name.

Specified by:
  `attribute` in interface `XmlSerializer`
Throws:
  `IOException`

#### closeStartTag

    protected void closeStartTag()
                          throws IOException

Throws:
  `IOException`

#### endTag

    public XmlSerializer endTag(String namespace,
                       String name)
                         throws IOException

Description copied from interface: `XmlSerializer`
Write end tag. Repetition of namespace and name is just for avoiding errors.

Background: in kXML endTag had no arguments, and non matching tags were very difficult to find... If namespace is null no namespace prefix is printed but just name. If namespace is empty string then serializer will make sure that default empty namespace is declared (in XML 1.0 xmlns='').

Specified by:
  `endTag` in interface `XmlSerializer`
Throws:
  `IOException`

#### text

    public XmlSerializer text(String text)
                       throws IOException

Description copied from interface: `XmlSerializer`
Writes text, where special XML chars are escaped automatically

Specified by:
  `text` in interface `XmlSerializer`
Throws:
  `IOException`

#### text

    public XmlSerializer text(char[] buf,
                     int start,
                     int len)
                       throws IOException

Description copied from interface: `XmlSerializer`
Writes text, where special XML chars are escaped automatically

Specified by:
  `text` in interface `XmlSerializer`
Throws:
  `IOException`

#### cdsect

    public void cdsect(String text)
                throws IOException

Specified by:
  `cdsect` in interface `XmlSerializer`
Throws:
  `IOException`

#### entityRef

    public void entityRef(String text)
                   throws IOException

Specified by:
  `entityRef` in interface `XmlSerializer`
Throws:
  `IOException`

#### processingInstruction

    public void processingInstruction(String text)
                               throws IOException

Specified by:
  `processingInstruction` in interface `XmlSerializer`
Throws:
  `IOException`

#### comment

    public void comment(String text)
                 throws IOException

Specified by:
  `comment` in interface `XmlSerializer`
Throws:
  `IOException`

#### docdecl

    public void docdecl(String text)
                 throws IOException

Specified by:
  `docdecl` in interface `XmlSerializer`
Throws:
  `IOException`

#### ignorableWhitespace

    public void ignorableWhitespace(String text)
                             throws IOException

Specified by:
  `ignorableWhitespace` in interface `XmlSerializer`
Throws:
  `IOException`

#### flush

    public void flush()
               throws IOException

Description copied from interface: `XmlSerializer`
Write all pending output to the stream. If method startTag() or attribute() was called then start tag is closed (final >) before flush() is called on underlying output stream.

NOTE: if there is need to close start tag (so no more attribute() calls are allowed) but without flushing output call method text() with empty string (text("")).

Specified by:
  `flush` in interface `XmlSerializer`
Throws:
  `IOException`

#### writeAttributeValue

    protected void writeAttributeValue(String value,
                           Writer out)
                                throws IOException

Throws:
  `IOException`

#### writeElementContent

    protected void writeElementContent(String text,
                           Writer out)
                                throws IOException

Throws:
  `IOException`

#### writeElementContent

    protected void writeElementContent(char[] buf,
                           int off,
                           int len,
                           Writer out)
                                throws IOException

Throws:
  `IOException`

#### printable

    protected static final String printable(String s)

simple utility method -- good for debugging

#### printable

    protected static final String printable(char ch)